;
; Oyd11, : mand set
; assembled with goldroad ARM 1.7
;

	b start
	
	@dup dcb 0xba,0				; room for header

start



palSet:
;;  set pal: entries are 256x555bpp I think
	mov	r0,#0x05000000 ; palette address
;
	mov r1,#32
	mov r2,#0 ; 0BGR
;
.r
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r

	subs r1,r1,#1
	bpl .r

	mov r1,#32
	mov r2,#0 ; 0BGR
;
.g
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ; g

	subs r1,r1,#1
	bpl .g

	mov r1,#32
	mov r2,#0 ; 0BGR

.b
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .b

	mov r1,#32
	mov r2,#0 ; 0BGR

.gray
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .gray

	; 128 entries

	mov r1,#32
	mov r2,#0 ; 0BGR

.yellow
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g

	subs r1,r1,#1
	bpl .yellow

	mov r1,#32
	mov r2,#0 ; 0BGR

.cyan
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .cyan

	mov r1,#32
	mov r2,#0 ; 0BGR

.magenta
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .magenta

	mov r1,#32
	mov r2,#(31<<10)
.blue2White
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .blue2White

	; 256 entries



	

;
;;	copy main loop to iwram 
;

	addr	r0,STARTIWRAM
	addr    r1,ENDIWRAM
	sub	r2,r1,r0
	mov	r1,effect
copycode:
	ldr	r3,[r0],#4
	str	r3,[r1],#4
	subs	r2,r2,#4
	bpl	copycode

;
;;	scale the mode 4 screen to make it larger veritically
;;	(older emus dont seem to support this)
;
	mov	r0,#0x04000000			; regs
	ldr	r1,=0x1444			; mode 4,bg 2 enabled,obj enabled,1d sprites
	str	r1,[r0]				; set screen mode
	ldrh	r1,[scale1]			; load h scale value (fixed point 8:8)
	strh	r1,[r0,$20]			; set h scale
	ldrh	r1,[scale2]			; load v scale value (fixed point 8:8)
	strh	r1,[r0,$26]			; set v scale

	addr	pc,effect			; branch to fire routine

scale1	@fixedw "1.0"
;scale2  @fixedw ".25"
scale2  @fixedw "1.0"
	@ltorg

;
;;	iwram code  
;


STARTIWRAM


effect:
; Res is 240x160

	;; strip patt:
bigLoop:
	mov 	r0,#0x06000000			; buffer


	mov	r3,160
	mvn r5,(2<<13) ; ci
;	mvn r5,(1<<13) ; ALT
l1:
	add r5,r5,($28<<9)/160 ; pixel delta
;	add r5,r5,($28<<8)/160 ; 
	mov r2,240
;	mvn r4,1<<13 ; 
	mvn r4,2<<13 ; 
l0:
	add r4,r4,($28<<9)/240 ; pixel delta
;	add r4,r4,($28<<8)/240 ; ALT vals

	mov r6,#0   ; a
	mov r7,#0   ; b

	mov r11,#0 ; colour counter
mandLoop
	mul r8,r6,r6 ; a*a
	mov r8,r8 ASR 13
	mul r9,r7,r7 ; b*b
;	mov r9,r9 ASR 13

; 2ab + ci:
	mul r7,r7,r6
	; can we 'post' shift result in one op instade?
	; shifts: LSL LSR ASR ROR
	add r7,r5,r7 ASR 12 ; shiftright
	; r7 = new Im ( a*b*2 +ci )

	add r10,r8,r9 ASR 13 ; a^2+b^2, check against 4
	sub r8,r8,r9 ASR 13 ; can we 'write' the shift to reg?
	add r6,r8,r4
	; r6 = new Re ( a^2-b^2 + cr )
	cmp r10,#4<<13
	bge outofLoop
	add r11,r11,1
	cmp r11,#31
	ble mandLoop
outofLoop

	add r11,r11,31
	strb 	r11,[r0],#1
	subs 	r2,r2,#1
	bne  	l0
	subs r3,r3,#1
	bne l1


doHalt2 ; is there a 'halt' mode like in GB classic?
	b doHalt2

;;	wait vsync
;	
	mov 	r1,#0x06000000			; vram
	mov	r0,#$04000000
waitvbl:
	ldrh	r1,[r0,#4]
	tst	r1,#1
	beq	waitvbl

;;	time to copy the buffer to the real screen
;;	(using dma chan 3)
;
	mov	r0,$04000000			; regs
	mov	r1,$03000000			; screen buffer
	mov	r2,$06000000			; destination
	str	r1,[r0,$D4]			; set src
	str	r2,[r0,$D8]			; set dest
	ldr	r2,=((240*160)>>2)		; count (32 bit words)
	strh	r2,[r0,$DC]			; set count
	mov	r2,%1000010000000000		; control: 32bit, start immediately
	strh	r2,[r0,$DE]			; set control (DMA starts)

;
;;	start over
;
doHalt ; is there a 'halt' mode like in GB classic?
	b doHalt
	

@ltorg

@endarea

ENDIWRAM

