;
; Oyd11, 2nd try on GBA: x+y strips
; assembled with goldroad ARM 1.7
;

	b start
	
	@dup dcb 0xba,0				; room for header

start



palSet:
;;  set pal: entries are 256x555bpp I think
	mov	r0,#0x05000000 ; palette address
;
	mov r1,#32
	mov r2,#0 ; 0BGR
;
.r
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r

	subs r1,r1,#1
	bpl .r

	mov r1,#32
	mov r2,#0 ; 0BGR
;
.g
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ; g

	subs r1,r1,#1
	bpl .g

	mov r1,#32
	mov r2,#0 ; 0BGR

.b
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .b

	mov r1,#32
	mov r2,#0 ; 0BGR

.gray
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .gray

	; 128 entries

	mov r1,#32
	mov r2,#0 ; 0BGR

.yellow
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g

	subs r1,r1,#1
	bpl .yellow

	mov r1,#32
	mov r2,#0 ; 0BGR

.cyan
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .cyan

	mov r1,#32
	mov r2,#0 ; 0BGR

.magenta
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .magenta

	mov r1,#32
	mov r2,#(31<<10)
.blue2White
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .blue2White

	; 256 entries



	

;
;;	copy main loop to iwram 
;

	addr	r0,STARTIWRAM
	addr    r1,ENDIWRAM
	sub	r2,r1,r0
	mov	r1,effect
copycode:
	ldr	r3,[r0],#4
	str	r3,[r1],#4
	subs	r2,r2,#4
	bpl	copycode

;
;;	scale the mode 4 screen to make it larger veritically
;;	(older emus dont seem to support this)
;
	mov	r0,#0x04000000			; regs
	ldr	r1,=0x1444			; mode 4,bg 2 enabled,obj enabled,1d sprites
	str	r1,[r0]				; set screen mode
	ldrh	r1,[scale1]			; load h scale value (fixed point 8:8)
	strh	r1,[r0,$20]			; set h scale
	ldrh	r1,[scale2]			; load v scale value (fixed point 8:8)
	strh	r1,[r0,$26]			; set v scale

	addr	pc,effect			; branch to fire routine

scale1	@fixedw "1.0"
;scale2  @fixedw ".25"
scale2  @fixedw "1.0"
	@ltorg

;
;;	iwram code  
;


STARTIWRAM


effect:
; Res is 240x160

	;; strip patt:
bigLoop:
	mov 	r0,#0x03000000			; buffer
	mov	r3,160
l1:
	mov r2,240
l0:
	add r4,r2,r3
	strb 	r4,[r0],#1
	subs 	r2,r2,#1
	bne  	l0
	subs r3,r3,#1
	bne l1

;;	wait vsync
;	
	mov 	r1,#0x06000000			; vram
	mov	r0,#$04000000
waitvbl:
	ldrh	r1,[r0,#4]
	tst	r1,#1
	beq	waitvbl

;;	time to copy the buffer to the real screen
;;	(using dma chan 3)
;
	mov	r0,$04000000			; regs
	mov	r1,$03000000			; screen buffer
	mov	r2,$06000000			; destination
	str	r1,[r0,$D4]			; set src
	str	r2,[r0,$D8]			; set dest
	ldr	r2,=((240*160)>>2)		; count (32 bit words)
	strh	r2,[r0,$DC]			; set count
	mov	r2,%1000010000000000		; control: 32bit, start immediately
	strh	r2,[r0,$DE]			; set control (DMA starts)

;
;;	start over
;
	b	bigLoop
	

@ltorg

@endarea

ENDIWRAM

